Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -2420,54 +2440,54 @@
 !> @bug if multiple files failed to be closed, only the last failure is given in the error message.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_finalize_output() RESULT( return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_finalize_output'  !< name of routine
-
-   INTEGER ::  f                      !< loop index
-   INTEGER ::  output_return_value    !< return value from called routines
-   INTEGER ::  return_value           !< return value
-   INTEGER ::  return_value_internal  !< error code after closing a single file
-
-
-   return_value = 0
-
-   DO  f = 1, nfiles
-
-      IF ( files(f)%is_init )  THEN
-
-         output_return_value = 0
-         return_value_internal = 0
-
-         SELECT CASE ( TRIM( files(f)%format ) )
-
-            CASE ( 'binary' )
-               CALL binary_finalize( files(f)%id, output_return_value )
-
-            CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-               CALL netcdf4_finalize( files(f)%id, output_return_value )
-
-            CASE DEFAULT
-               return_value_internal = 1
-
-         END SELECT
-
-         IF ( output_return_value /= 0 )  THEN
-            return_value = output_return_value
-            CALL internal_message( 'error', routine_name //             &
-                                   ': error while finalizing file "' // &
-                                   TRIM( files(f)%name ) // '"' )
-         ELSEIF ( return_value_internal /= 0 )  THEN
-            return_value = return_value_internal
-            CALL internal_message( 'error', routine_name //                     &
-                                   ': unsupported file format "' //             &
-                                   TRIM( files(f)%format ) // '" for file "' // &
-                                   TRIM( files(f)%name ) // '"' )
-         ENDIF
-
-      ENDIF
-
-   ENDDO
-
-END FUNCTION dom_finalize_output
+ FUNCTION dom_finalize_output() RESULT( return_value )
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_finalize_output'  !< name of routine
+
+    INTEGER ::  f                      !< loop index
+    INTEGER ::  output_return_value    !< return value from called routines
+    INTEGER ::  return_value           !< return value
+    INTEGER ::  return_value_internal  !< error code after closing a single file
+
+
+    return_value = 0
+
+    DO  f = 1, nfiles
+
+       IF ( files(f)%is_init )  THEN
+
+          output_return_value = 0
+          return_value_internal = 0
+
+          SELECT CASE ( TRIM( files(f)%format ) )
+
+             CASE ( 'binary' )
+                CALL binary_finalize( files(f)%id, output_return_value )
+
+             CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+                CALL netcdf4_finalize( files(f)%id, output_return_value )
+
+             CASE DEFAULT
+                return_value_internal = 1
+
+          END SELECT
+
+          IF ( output_return_value /= 0 )  THEN
+             return_value = output_return_value
+             CALL internal_message( 'error', routine_name //             &
+                                    ': error while finalizing file "' // &
+                                    TRIM( files(f)%name ) // '"' )
+          ELSEIF ( return_value_internal /= 0 )  THEN
+             return_value = return_value_internal
+             CALL internal_message( 'error', routine_name //                     &
+                                    ': unsupported file format "' //             &
+                                    TRIM( files(f)%format ) // '" for file "' // &
+                                    TRIM( files(f)%name ) // '"' )
+          ENDIF
+
+       ENDIF
+
+    ENDDO
+
+ END FUNCTION dom_finalize_output
 
 !--------------------------------------------------------------------------------------------------!
@@ -2476,18 +2496,18 @@
 !> Return the last created error message.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_get_error_message() RESULT( error_message )
-
-   CHARACTER(LEN=800) ::  error_message  !< return error message to main program
-
-
-   error_message = TRIM( internal_error_message )
-
-   error_message = TRIM( error_message ) // TRIM( binary_get_error_message() )
-   
-   error_message = TRIM( error_message ) // TRIM( netcdf4_get_error_message() )
-   
-   internal_error_message = ''
-
-END FUNCTION dom_get_error_message
+ FUNCTION dom_get_error_message() RESULT( error_message )
+
+    CHARACTER(LEN=800) ::  error_message  !< return error message to main program
+
+
+    error_message = TRIM( internal_error_message )
+
+    error_message = TRIM( error_message ) // TRIM( binary_get_error_message() )
+
+    error_message = TRIM( error_message ) // TRIM( netcdf4_get_error_message() )
+
+    internal_error_message = ''
+
+ END FUNCTION dom_get_error_message
 
 !--------------------------------------------------------------------------------------------------!
@@ -2498,237 +2518,244 @@
 !> @todo Try to combine similar code parts and shorten routine.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION save_attribute_in_database( file_name, variable_name, attribute, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
-   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'save_attribute_in_database'  !< name of routine
-
-   INTEGER ::  a             !< loop index
-   INTEGER ::  d             !< loop index
-   INTEGER ::  f             !< loop index
-   INTEGER ::  natts         !< number of attributes
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL             ::  found   !< true if variable or dimension of name 'variable_name' found
-   LOGICAL, INTENT(IN) ::  append  !< if true, append value to existing value
-
-   TYPE(attribute_type), INTENT(IN) ::  attribute  !< new attribute
-
-   TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  atts_tmp  !< temporary attribute list
-
-
-   return_value = 0
-   found = .FALSE.
-
-   CALL internal_message( 'debug', routine_name //                            &
-                          ': define attribute "' // TRIM( attribute%name ) // &
-                          '" of variable "' // TRIM( variable_name ) //       &
-                          '" in file "' // TRIM( file_name ) // '"' )
-
-   DO  f = 1, nfiles
-
-      IF ( TRIM( file_name ) == files(f)%name )  THEN
-
-         IF ( files(f)%is_init )  THEN
-            return_value = 1
-            CALL internal_message( 'error', routine_name // ': file "' // TRIM( file_name ) // &
-                    '" is already initialized. No further attribute definition allowed!' )
-            EXIT
-         ENDIF
-
-         !-- Add attribute to file
-         IF ( TRIM( variable_name ) == '' )  THEN
-
-            !-- Initialize first file attribute
-            IF ( .NOT. ALLOCATED( files(f)%attributes ) )  THEN
-               natts = 1
-               ALLOCATE( files(f)%attributes(natts) )
-            ELSE
-               natts = SIZE( files(f)%attributes )
-
-               !-- Check if attribute already exists
-               DO  a = 1, natts
-                  IF ( files(f)%attributes(a)%name == attribute%name )  THEN
-                     IF ( append )  THEN
-                        !-- Append existing string attribute
-                        files(f)%attributes(a)%value_char =             &
-                           TRIM( files(f)%attributes(a)%value_char ) // &
-                           TRIM( attribute%value_char )
-                     ELSE
-                        files(f)%attributes(a) = attribute
-                     ENDIF
-                     found = .TRUE.
-                     EXIT
-                  ENDIF
-               ENDDO
-
-               !-- Extend attribute list by 1
-               IF ( .NOT. found )  THEN
-                  ALLOCATE( atts_tmp(natts) )
-                  atts_tmp = files(f)%attributes
-                  DEALLOCATE( files(f)%attributes )
-                  natts = natts + 1
-                  ALLOCATE( files(f)%attributes(natts) )
-                  files(f)%attributes(:natts-1) = atts_tmp
-                  DEALLOCATE( atts_tmp )
-               ENDIF
-            ENDIF
-
-            !-- Save new attribute to the end of the attribute list
-            IF ( .NOT. found )  THEN
-               files(f)%attributes(natts) = attribute
-               found = .TRUE.
-            ENDIF
-
-            EXIT
-
-         ELSE
-
-            !-- Add attribute to dimension
-            IF ( ALLOCATED( files(f)%dimensions ) )  THEN
-
-               DO  d = 1, SIZE( files(f)%dimensions )
-
-                  IF ( files(f)%dimensions(d)%name == TRIM( variable_name ) )  THEN
-
-                     IF ( .NOT. ALLOCATED( files(f)%dimensions(d)%attributes ) )  THEN
-                        !-- Initialize first attribute
-                        natts = 1
-                        ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
-                     ELSE
-                        natts = SIZE( files(f)%dimensions(d)%attributes )
-
-                        !-- Check if attribute already exists
-                        DO  a = 1, natts
-                           IF ( files(f)%dimensions(d)%attributes(a)%name == attribute%name ) &
-                           THEN
-                              IF ( append )  THEN
-                                 !-- Append existing character attribute
-                                 files(f)%dimensions(d)%attributes(a)%value_char =             &
-                                    TRIM( files(f)%dimensions(d)%attributes(a)%value_char ) // &
-                                    TRIM( attribute%value_char )
-                              ELSE
-                                 !-- Update existing attribute
-                                 files(f)%dimensions(d)%attributes(a) = attribute
-                              ENDIF
-                              found = .TRUE.
-                              EXIT
-                           ENDIF
-                        ENDDO
-
-                        !-- Extend attribute list
-                        IF ( .NOT. found )  THEN
-                           ALLOCATE( atts_tmp(natts) )
-                           atts_tmp = files(f)%dimensions(d)%attributes
-                           DEALLOCATE( files(f)%dimensions(d)%attributes )
-                           natts = natts + 1
-                           ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
-                           files(f)%dimensions(d)%attributes(:natts-1) = atts_tmp
-                           DEALLOCATE( atts_tmp )
-                        ENDIF
-                     ENDIF
-
-                     !-- Add new attribute to database
-                     IF ( .NOT. found )  THEN
-                        files(f)%dimensions(d)%attributes(natts) = attribute
-                        found = .TRUE.
-                     ENDIF
-
-                     EXIT
-
-                  ENDIF  ! dimension found
-
-               ENDDO  ! loop over dimensions
-
-            ENDIF  ! dimensions exist in file
-
-            !-- Add attribute to variable
-            IF ( .NOT. found  .AND.  ALLOCATED( files(f)%variables) )  THEN
-
-               DO  d = 1, SIZE( files(f)%variables )
-
-                  IF ( files(f)%variables(d)%name == TRIM( variable_name ) )  THEN
-
-                     IF ( .NOT. ALLOCATED( files(f)%variables(d)%attributes ) )  THEN
-                        !-- Initialize first attribute
-                        natts = 1
-                        ALLOCATE( files(f)%variables(d)%attributes(natts) )
-                     ELSE
-                        natts = SIZE( files(f)%variables(d)%attributes )
-
-                        !-- Check if attribute already exists
-                        DO  a = 1, natts
-                           IF ( files(f)%variables(d)%attributes(a)%name == attribute%name )  &
-                           THEN
-                              IF ( append )  THEN
-                                 !-- Append existing character attribute
-                                 files(f)%variables(d)%attributes(a)%value_char =             &
-                                    TRIM( files(f)%variables(d)%attributes(a)%value_char ) // &
-                                    TRIM( attribute%value_char )
-                              ELSE
-                                 !-- Update existing attribute
-                                 files(f)%variables(d)%attributes(a) = attribute
-                              ENDIF
-                              found = .TRUE.
-                              EXIT
-                           ENDIF
-                        ENDDO
-
-                        !-- Extend attribute list
-                        IF ( .NOT. found )  THEN
-                           ALLOCATE( atts_tmp(natts) )
-                           atts_tmp = files(f)%variables(d)%attributes
-                           DEALLOCATE( files(f)%variables(d)%attributes )
-                           natts = natts + 1
-                           ALLOCATE( files(f)%variables(d)%attributes(natts) )
-                           files(f)%variables(d)%attributes(:natts-1) = atts_tmp
-                           DEALLOCATE( atts_tmp )
-                        ENDIF
-
-                     ENDIF
-
-                     !-- Add new attribute to database
-                     IF ( .NOT. found )  THEN
-                        files(f)%variables(d)%attributes(natts) = attribute
-                        found = .TRUE.
-                     ENDIF
-
-                     EXIT
-
-                  ENDIF  ! variable found
-
-               ENDDO  ! loop over variables
-
-            ENDIF  ! variables exist in file
-
-            IF ( .NOT. found )  THEN
-               return_value = 1
-               CALL internal_message( 'error',                                        &
-                       routine_name //                                                &
-                       ': requested dimension/variable "' // TRIM( variable_name ) // &
-                       '" for attribute "' // TRIM( attribute%name ) //               &
-                       '" does not exist in file "' // TRIM( file_name ) // '"' )
-            ENDIF
-
-            EXIT
-
-         ENDIF  ! variable_name not empty
-
-      ENDIF  ! check file_name
-
-   ENDDO  ! loop over files
-
-   IF ( .NOT. found  .AND.  return_value == 0 )  THEN
-      return_value = 1
-      CALL internal_message( 'error',                                         &
-                             routine_name //                                  &
-                             ': requested file "' // TRIM( file_name ) //     &
-                             '" for attribute "' // TRIM( attribute%name ) // &
-                             '" does not exist' )
-   ENDIF
-
-END FUNCTION save_attribute_in_database
+ FUNCTION save_attribute_in_database( file_name, variable_name, attribute, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
+    CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'save_attribute_in_database'  !< name of routine
+
+    INTEGER ::  a             !< loop index
+    INTEGER ::  d             !< loop index
+    INTEGER ::  f             !< loop index
+    INTEGER ::  natts         !< number of attributes
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL             ::  found   !< true if variable or dimension of name 'variable_name' found
+    LOGICAL, INTENT(IN) ::  append  !< if true, append value to existing value
+
+    TYPE(attribute_type), INTENT(IN) ::  attribute  !< new attribute
+
+    TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  atts_tmp  !< temporary attribute list
+
+
+    return_value = 0
+    found = .FALSE.
+
+    CALL internal_message( 'debug', routine_name //                            &
+                           ': define attribute "' // TRIM( attribute%name ) // &
+                           '" of variable "' // TRIM( variable_name ) //       &
+                           '" in file "' // TRIM( file_name ) // '"' )
+
+    DO  f = 1, nfiles
+
+       IF ( TRIM( file_name ) == files(f)%name )  THEN
+
+          IF ( files(f)%is_init )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name // ': file "' // TRIM( file_name ) // &
+                     '" is already initialized. No further attribute definition allowed!' )
+             EXIT
+          ENDIF
+!
+!--       Add attribute to file
+          IF ( TRIM( variable_name ) == '' )  THEN
+!
+!--          Initialize first file attribute
+             IF ( .NOT. ALLOCATED( files(f)%attributes ) )  THEN
+                natts = 1
+                ALLOCATE( files(f)%attributes(natts) )
+             ELSE
+                natts = SIZE( files(f)%attributes )
+!
+!--             Check if attribute already exists
+                DO  a = 1, natts
+                   IF ( files(f)%attributes(a)%name == attribute%name )  THEN
+                      IF ( append )  THEN
+!
+!--                      Append existing string attribute
+                         files(f)%attributes(a)%value_char =             &
+                            TRIM( files(f)%attributes(a)%value_char ) // &
+                            TRIM( attribute%value_char )
+                      ELSE
+                         files(f)%attributes(a) = attribute
+                      ENDIF
+                      found = .TRUE.
+                      EXIT
+                   ENDIF
+                ENDDO
+!
+!--             Extend attribute list by 1
+                IF ( .NOT. found )  THEN
+                   ALLOCATE( atts_tmp(natts) )
+                   atts_tmp = files(f)%attributes
+                   DEALLOCATE( files(f)%attributes )
+                   natts = natts + 1
+                   ALLOCATE( files(f)%attributes(natts) )
+                   files(f)%attributes(:natts-1) = atts_tmp
+                   DEALLOCATE( atts_tmp )
+                ENDIF
+             ENDIF
+!
+!--          Save new attribute to the end of the attribute list
+             IF ( .NOT. found )  THEN
+                files(f)%attributes(natts) = attribute
+                found = .TRUE.
+             ENDIF
+
+             EXIT
+
+          ELSE
+!
+!--          Add attribute to dimension
+             IF ( ALLOCATED( files(f)%dimensions ) )  THEN
+
+                DO  d = 1, SIZE( files(f)%dimensions )
+
+                   IF ( files(f)%dimensions(d)%name == TRIM( variable_name ) )  THEN
+
+                      IF ( .NOT. ALLOCATED( files(f)%dimensions(d)%attributes ) )  THEN
+!
+!--                      Initialize first attribute
+                         natts = 1
+                         ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
+                      ELSE
+                         natts = SIZE( files(f)%dimensions(d)%attributes )
+!
+!--                      Check if attribute already exists
+                         DO  a = 1, natts
+                            IF ( files(f)%dimensions(d)%attributes(a)%name == attribute%name ) &
+                            THEN
+                               IF ( append )  THEN
+!
+!--                               Append existing character attribute
+                                  files(f)%dimensions(d)%attributes(a)%value_char =             &
+                                     TRIM( files(f)%dimensions(d)%attributes(a)%value_char ) // &
+                                     TRIM( attribute%value_char )
+                               ELSE
+!
+!--                               Update existing attribute
+                                  files(f)%dimensions(d)%attributes(a) = attribute
+                               ENDIF
+                               found = .TRUE.
+                               EXIT
+                            ENDIF
+                         ENDDO
+!
+!--                      Extend attribute list
+                         IF ( .NOT. found )  THEN
+                            ALLOCATE( atts_tmp(natts) )
+                            atts_tmp = files(f)%dimensions(d)%attributes
+                            DEALLOCATE( files(f)%dimensions(d)%attributes )
+                            natts = natts + 1
+                            ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
+                            files(f)%dimensions(d)%attributes(:natts-1) = atts_tmp
+                            DEALLOCATE( atts_tmp )
+                         ENDIF
+                      ENDIF
+!
+!--                   Add new attribute to database
+                      IF ( .NOT. found )  THEN
+                         files(f)%dimensions(d)%attributes(natts) = attribute
+                         found = .TRUE.
+                      ENDIF
+
+                      EXIT
+
+                   ENDIF  ! dimension found
+
+                ENDDO  ! loop over dimensions
+
+             ENDIF  ! dimensions exist in file
+!
+!--          Add attribute to variable
+             IF ( .NOT. found  .AND.  ALLOCATED( files(f)%variables) )  THEN
+
+                DO  d = 1, SIZE( files(f)%variables )
+
+                   IF ( files(f)%variables(d)%name == TRIM( variable_name ) )  THEN
+
+                      IF ( .NOT. ALLOCATED( files(f)%variables(d)%attributes ) )  THEN
+!
+!--                      Initialize first attribute
+                         natts = 1
+                         ALLOCATE( files(f)%variables(d)%attributes(natts) )
+                      ELSE
+                         natts = SIZE( files(f)%variables(d)%attributes )
+!
+!--                      Check if attribute already exists
+                         DO  a = 1, natts
+                            IF ( files(f)%variables(d)%attributes(a)%name == attribute%name )  &
+                            THEN
+                               IF ( append )  THEN
+!
+!--                               Append existing character attribute
+                                  files(f)%variables(d)%attributes(a)%value_char =             &
+                                     TRIM( files(f)%variables(d)%attributes(a)%value_char ) // &
+                                     TRIM( attribute%value_char )
+                               ELSE
+!
+!--                               Update existing attribute
+                                  files(f)%variables(d)%attributes(a) = attribute
+                               ENDIF
+                               found = .TRUE.
+                               EXIT
+                            ENDIF
+                         ENDDO
+!
+!--                      Extend attribute list
+                         IF ( .NOT. found )  THEN
+                            ALLOCATE( atts_tmp(natts) )
+                            atts_tmp = files(f)%variables(d)%attributes
+                            DEALLOCATE( files(f)%variables(d)%attributes )
+                            natts = natts + 1
+                            ALLOCATE( files(f)%variables(d)%attributes(natts) )
+                            files(f)%variables(d)%attributes(:natts-1) = atts_tmp
+                            DEALLOCATE( atts_tmp )
+                         ENDIF
+
+                      ENDIF
+!
+!--                   Add new attribute to database
+                      IF ( .NOT. found )  THEN
+                         files(f)%variables(d)%attributes(natts) = attribute
+                         found = .TRUE.
+                      ENDIF
+
+                      EXIT
+
+                   ENDIF  ! variable found
+
+                ENDDO  ! loop over variables
+
+             ENDIF  ! variables exist in file
+
+             IF ( .NOT. found )  THEN
+                return_value = 1
+                CALL internal_message( 'error',                                        &
+                        routine_name //                                                &
+                        ': requested dimension/variable "' // TRIM( variable_name ) // &
+                        '" for attribute "' // TRIM( attribute%name ) //               &
+                        '" does not exist in file "' // TRIM( file_name ) // '"' )
+             ENDIF
+
+             EXIT
+
+          ENDIF  ! variable_name not empty
+
+       ENDIF  ! check file_name
+
+    ENDDO  ! loop over files
+
+    IF ( .NOT. found  .AND.  return_value == 0 )  THEN
+       return_value = 1
+       CALL internal_message( 'error',                                         &
+                              routine_name //                                  &
+                              ': requested file "' // TRIM( file_name ) //     &
+                              '" for attribute "' // TRIM( attribute%name ) // &
+                              '" does not exist' )
+    ENDIF
+
+ END FUNCTION save_attribute_in_database
 
 !--------------------------------------------------------------------------------------------------!
